/* ---------------------------------------------------------------- */
//
// MagIO.h
//
// Created by Christoph Birk on 2014-10-03
// Copyright 2014 Carnegie Observatories. All rights reserved.
//
/* ---------------------------------------------------------------- */

#import "Tcpip.h"

/* ---------------------------------------------------------------- */

enum magio_errors_enum { E_magio_error=E_tcpip_error+100,
                         E_magio_timeout,
                         E_magio_reject1,
                         E_magio_reject2,
                         E_magio_reject3,
                         E_magio_last
};

/* ---------------------------------------------------------------- */

@interface MagIO : TCPIP_Connection
{
}

- (int)getAlpha:(double*)a delta:(double*)d equinox:(double*)e;
- (int)getAlpha:(double*)a delta:(double*)d equinox:(double)e rot:(float*)r;
- (int)setAlpha:(double)a delta:(double)d equinox:(double)e rot:(float)r;
- (int)setAlpha:(double)a delta:(double)d equinox:(double)e;
- (int)moveOffsetRA:(float)dx dec:(float)dy;
- (int)moveOffsetAz:(float)da el:(float)de;

- (int)waitMount:(int)coordinated timeout:(int)timeout;

- (int)setGuiding:(int)g1 g2:(int)g2 timeout:(int)timeout;
- (int)waitGuiding:(int)timeout;

- (int)moveGprobes:(float)dx1 dy1:(float)dy1 dx2:(float)dx2 dy2:(float)dy2;
- (int)dragGprobes:(int)mode az:(float)da el:(float)de;
- (int)waitGprobes:(int)timeout;
- (int)getGprobe:(int)gp f:(float*)focus x:(float*)xpos y:(float*)ypos;
- (int)setGprobe:(int)gp focus:(float)focus;

- (int)getUT:(int*)ut st:(int*)st;
- (int)getWXT:(float*)temp p:(float*)pres h:(float*)humi w:(float*)wind d:(float*)wdir;
- (int)getAmbient:(float*)ta cell:(float*)tc truss:(float*)tt m2:(float*)t2;

- (int)getAirmass:(float*)am rotangle:(float*)ra rotatore:(float*)re
          azimuth:(float*)az elevation:(float*)el para:(float*)pa;

- (int)getCatalog:(char*)name;

@end

/* ---------------------------------------------------------------- */
/* ---------------------------------------------------------------- */
/* ---------------------------------------------------------------- */
